-- 
-- Created by SQL::Translator::Producer::MySQL
-- Created on Sun Jan 22 09:32:02 2012
-- 
SET foreign_key_checks=0;

DROP TABLE IF EXISTS `artist`;

--
-- Table: `artist`
--
CREATE TABLE `artist` (
  `artistid` integer NOT NULL auto_increment,
  `name` varchar(100),
  `rank` integer NOT NULL DEFAULT 13,
  `charfield` char(10),
  PRIMARY KEY (`artistid`),
  UNIQUE `artist_name` (`name`),
  UNIQUE `u_nullable` (`charfield`, `rank`)
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `bindtype_test`;

--
-- Table: `bindtype_test`
--
CREATE TABLE `bindtype_test` (
  `id` integer NOT NULL auto_increment,
  `bytea` BLOB,
  `blob` blob,
  `clob` longtext,
  `a_memo` memo,
  PRIMARY KEY (`id`)
);

DROP TABLE IF EXISTS `collection`;

--
-- Table: `collection`
--
CREATE TABLE `collection` (
  `collectionid` integer NOT NULL auto_increment,
  `name` varchar(100) NOT NULL,
  PRIMARY KEY (`collectionid`)
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `encoded`;

--
-- Table: `encoded`
--
CREATE TABLE `encoded` (
  `id` integer NOT NULL auto_increment,
  `encoded` varchar(100),
  PRIMARY KEY (`id`)
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `event`;

--
-- Table: `event`
--
CREATE TABLE `event` (
  `id` integer NOT NULL auto_increment,
  `starts_at` date NOT NULL,
  `created_on` timestamp NOT NULL,
  `varchar_date` varchar(20),
  `varchar_datetime` varchar(20),
  `skip_inflation` datetime,
  `ts_without_tz` datetime,
  PRIMARY KEY (`id`)
);

DROP TABLE IF EXISTS `fourkeys`;

--
-- Table: `fourkeys`
--
CREATE TABLE `fourkeys` (
  `foo` integer NOT NULL,
  `bar` integer NOT NULL,
  `hello` integer NOT NULL,
  `goodbye` integer NOT NULL,
  `sensors` character(10) NOT NULL,
  `read_count` integer,
  PRIMARY KEY (`foo`, `bar`, `hello`, `goodbye`)
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `genre`;

--
-- Table: `genre`
--
CREATE TABLE `genre` (
  `genreid` integer NOT NULL auto_increment,
  `name` varchar(100) NOT NULL,
  PRIMARY KEY (`genreid`),
  UNIQUE `genre_name` (`name`)
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `link`;

--
-- Table: `link`
--
CREATE TABLE `link` (
  `id` integer NOT NULL auto_increment,
  `url` varchar(100),
  `title` varchar(100),
  PRIMARY KEY (`id`)
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `money_test`;

--
-- Table: `money_test`
--
CREATE TABLE `money_test` (
  `id` integer NOT NULL auto_increment,
  `amount` float,
  PRIMARY KEY (`id`)
);

DROP TABLE IF EXISTS `noprimarykey`;

--
-- Table: `noprimarykey`
--
CREATE TABLE `noprimarykey` (
  `foo` integer NOT NULL,
  `bar` integer NOT NULL,
  `baz` integer NOT NULL,
  UNIQUE `foo_bar` (`foo`, `bar`)
);

DROP TABLE IF EXISTS `onekey`;

--
-- Table: `onekey`
--
CREATE TABLE `onekey` (
  `id` integer NOT NULL auto_increment,
  `artist` integer NOT NULL,
  `cd` integer NOT NULL,
  PRIMARY KEY (`id`)
);

DROP TABLE IF EXISTS `owners`;

--
-- Table: `owners`
--
CREATE TABLE `owners` (
  `id` integer NOT NULL auto_increment,
  `name` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `producer`;

--
-- Table: `producer`
--
CREATE TABLE `producer` (
  `producerid` integer NOT NULL auto_increment,
  `name` varchar(100) NOT NULL,
  PRIMARY KEY (`producerid`),
  UNIQUE `prod_name` (`name`)
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `self_ref`;

--
-- Table: `self_ref`
--
CREATE TABLE `self_ref` (
  `id` integer NOT NULL auto_increment,
  `name` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `sequence_test`;

--
-- Table: `sequence_test`
--
CREATE TABLE `sequence_test` (
  `pkid1` integer NOT NULL,
  `pkid2` integer NOT NULL,
  `nonpkid` integer NOT NULL,
  `name` varchar(100),
  PRIMARY KEY (`pkid1`, `pkid2`)
);

DROP TABLE IF EXISTS `serialized`;

--
-- Table: `serialized`
--
CREATE TABLE `serialized` (
  `id` integer NOT NULL auto_increment,
  `serialized` text NOT NULL,
  PRIMARY KEY (`id`)
);

DROP TABLE IF EXISTS `timestamp_primary_key_test`;

--
-- Table: `timestamp_primary_key_test`
--
CREATE TABLE `timestamp_primary_key_test` (
  `id` timestamp NOT NULL DEFAULT current_timestamp,
  PRIMARY KEY (`id`)
);

DROP TABLE IF EXISTS `treelike`;

--
-- Table: `treelike`
--
CREATE TABLE `treelike` (
  `id` integer NOT NULL auto_increment,
  `parent` integer,
  `name` varchar(100) NOT NULL,
  INDEX `treelike_idx_parent` (`parent`),
  PRIMARY KEY (`id`),
  CONSTRAINT `treelike_fk_parent` FOREIGN KEY (`parent`) REFERENCES `treelike` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `twokeytreelike`;

--
-- Table: `twokeytreelike`
--
CREATE TABLE `twokeytreelike` (
  `id1` integer NOT NULL,
  `id2` integer NOT NULL,
  `parent1` integer NOT NULL,
  `parent2` integer NOT NULL,
  `name` varchar(100) NOT NULL,
  INDEX `twokeytreelike_idx_parent1_parent2` (`parent1`, `parent2`),
  PRIMARY KEY (`id1`, `id2`),
  UNIQUE `tktlnameunique` (`name`),
  CONSTRAINT `twokeytreelike_fk_parent1_parent2` FOREIGN KEY (`parent1`, `parent2`) REFERENCES `twokeytreelike` (`id1`, `id2`)
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `typed_object`;

--
-- Table: `typed_object`
--
CREATE TABLE `typed_object` (
  `objectid` integer NOT NULL auto_increment,
  `type` varchar(100) NOT NULL,
  `value` varchar(100) NOT NULL,
  PRIMARY KEY (`objectid`)
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `artist_undirected_map`;

--
-- Table: `artist_undirected_map`
--
CREATE TABLE `artist_undirected_map` (
  `id1` integer NOT NULL,
  `id2` integer NOT NULL,
  INDEX `artist_undirected_map_idx_id1` (`id1`),
  INDEX `artist_undirected_map_idx_id2` (`id2`),
  PRIMARY KEY (`id1`, `id2`),
  CONSTRAINT `artist_undirected_map_fk_id1` FOREIGN KEY (`id1`) REFERENCES `artist` (`artistid`) ON DELETE RESTRICT ON UPDATE CASCADE,
  CONSTRAINT `artist_undirected_map_fk_id2` FOREIGN KEY (`id2`) REFERENCES `artist` (`artistid`)
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `bookmark`;

--
-- Table: `bookmark`
--
CREATE TABLE `bookmark` (
  `id` integer NOT NULL auto_increment,
  `link` integer,
  INDEX `bookmark_idx_link` (`link`),
  PRIMARY KEY (`id`),
  CONSTRAINT `bookmark_fk_link` FOREIGN KEY (`link`) REFERENCES `link` (`id`) ON DELETE SET NULL ON UPDATE CASCADE
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `books`;

--
-- Table: `books`
--
CREATE TABLE `books` (
  `id` integer NOT NULL auto_increment,
  `source` varchar(100) NOT NULL,
  `owner` integer NOT NULL,
  `title` varchar(100) NOT NULL,
  `price` integer,
  INDEX `books_idx_owner` (`owner`),
  PRIMARY KEY (`id`),
  UNIQUE `books_title` (`title`),
  CONSTRAINT `books_fk_owner` FOREIGN KEY (`owner`) REFERENCES `owners` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `employee`;

--
-- Table: `employee`
--
CREATE TABLE `employee` (
  `employee_id` integer NOT NULL auto_increment,
  `position` integer NOT NULL,
  `group_id` integer,
  `group_id_2` integer,
  `group_id_3` integer,
  `name` varchar(100),
  `encoded` integer,
  INDEX `employee_idx_encoded` (`encoded`),
  PRIMARY KEY (`employee_id`),
  CONSTRAINT `employee_fk_encoded` FOREIGN KEY (`encoded`) REFERENCES `encoded` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `forceforeign`;

--
-- Table: `forceforeign`
--
CREATE TABLE `forceforeign` (
  `artist` integer NOT NULL,
  `cd` integer NOT NULL,
  INDEX (`artist`),
  PRIMARY KEY (`artist`),
  CONSTRAINT `forceforeign_fk_artist` FOREIGN KEY (`artist`) REFERENCES `artist` (`artistid`)
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `self_ref_alias`;

--
-- Table: `self_ref_alias`
--
CREATE TABLE `self_ref_alias` (
  `self_ref` integer NOT NULL,
  `alias` integer NOT NULL,
  INDEX `self_ref_alias_idx_alias` (`alias`),
  INDEX `self_ref_alias_idx_self_ref` (`self_ref`),
  PRIMARY KEY (`self_ref`, `alias`),
  CONSTRAINT `self_ref_alias_fk_alias` FOREIGN KEY (`alias`) REFERENCES `self_ref` (`id`),
  CONSTRAINT `self_ref_alias_fk_self_ref` FOREIGN KEY (`self_ref`) REFERENCES `self_ref` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `track`;

--
-- Table: `track`
--
CREATE TABLE `track` (
  `trackid` integer NOT NULL auto_increment,
  `cd` integer NOT NULL,
  `position` integer NOT NULL,
  `title` varchar(100) NOT NULL,
  `last_updated_on` datetime,
  `last_updated_at` datetime,
  INDEX `track_idx_cd` (`cd`),
  PRIMARY KEY (`trackid`),
  UNIQUE `track_cd_position` (`cd`, `position`),
  UNIQUE `track_cd_title` (`cd`, `title`),
  CONSTRAINT `track_fk_cd` FOREIGN KEY (`cd`) REFERENCES `cd` (`cdid`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `cd`;

--
-- Table: `cd`
--
CREATE TABLE `cd` (
  `cdid` integer NOT NULL auto_increment,
  `artist` integer NOT NULL,
  `title` varchar(100) NOT NULL,
  `year` varchar(100) NOT NULL,
  `genreid` integer,
  `single_track` integer,
  INDEX `cd_idx_artist` (`artist`),
  INDEX `cd_idx_genreid` (`genreid`),
  INDEX `cd_idx_single_track` (`single_track`),
  PRIMARY KEY (`cdid`),
  UNIQUE `cd_artist_title` (`artist`, `title`),
  CONSTRAINT `cd_fk_artist` FOREIGN KEY (`artist`) REFERENCES `artist` (`artistid`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `cd_fk_genreid` FOREIGN KEY (`genreid`) REFERENCES `genre` (`genreid`) ON DELETE SET NULL ON UPDATE CASCADE,
  CONSTRAINT `cd_fk_single_track` FOREIGN KEY (`single_track`) REFERENCES `track` (`trackid`) ON DELETE CASCADE
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `collection_object`;

--
-- Table: `collection_object`
--
CREATE TABLE `collection_object` (
  `collection` integer NOT NULL,
  `object` integer NOT NULL,
  INDEX `collection_object_idx_collection` (`collection`),
  INDEX `collection_object_idx_object` (`object`),
  PRIMARY KEY (`collection`, `object`),
  CONSTRAINT `collection_object_fk_collection` FOREIGN KEY (`collection`) REFERENCES `collection` (`collectionid`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `collection_object_fk_object` FOREIGN KEY (`object`) REFERENCES `typed_object` (`objectid`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `lyrics`;

--
-- Table: `lyrics`
--
CREATE TABLE `lyrics` (
  `lyric_id` integer NOT NULL auto_increment,
  `track_id` integer NOT NULL,
  INDEX `lyrics_idx_track_id` (`track_id`),
  PRIMARY KEY (`lyric_id`),
  CONSTRAINT `lyrics_fk_track_id` FOREIGN KEY (`track_id`) REFERENCES `track` (`trackid`) ON DELETE CASCADE
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `cd_artwork`;

--
-- Table: `cd_artwork`
--
CREATE TABLE `cd_artwork` (
  `cd_id` integer NOT NULL,
  INDEX (`cd_id`),
  PRIMARY KEY (`cd_id`),
  CONSTRAINT `cd_artwork_fk_cd_id` FOREIGN KEY (`cd_id`) REFERENCES `cd` (`cdid`) ON DELETE CASCADE
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `liner_notes`;

--
-- Table: `liner_notes`
--
CREATE TABLE `liner_notes` (
  `liner_id` integer NOT NULL,
  `notes` varchar(100) NOT NULL,
  INDEX (`liner_id`),
  PRIMARY KEY (`liner_id`),
  CONSTRAINT `liner_notes_fk_liner_id` FOREIGN KEY (`liner_id`) REFERENCES `cd` (`cdid`) ON DELETE CASCADE
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `lyric_versions`;

--
-- Table: `lyric_versions`
--
CREATE TABLE `lyric_versions` (
  `id` integer NOT NULL auto_increment,
  `lyric_id` integer NOT NULL,
  `text` varchar(100) NOT NULL,
  INDEX `lyric_versions_idx_lyric_id` (`lyric_id`),
  PRIMARY KEY (`id`),
  CONSTRAINT `lyric_versions_fk_lyric_id` FOREIGN KEY (`lyric_id`) REFERENCES `lyrics` (`lyric_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `tags`;

--
-- Table: `tags`
--
CREATE TABLE `tags` (
  `tagid` integer NOT NULL auto_increment,
  `cd` integer NOT NULL,
  `tag` varchar(100) NOT NULL,
  INDEX `tags_idx_cd` (`cd`),
  PRIMARY KEY (`tagid`),
  UNIQUE `tagid_cd` (`tagid`, `cd`),
  UNIQUE `tagid_cd_tag` (`tagid`, `cd`, `tag`),
  UNIQUE `tags_tagid_tag` (`tagid`, `tag`),
  UNIQUE `tags_tagid_tag_cd` (`tagid`, `tag`, `cd`),
  CONSTRAINT `tags_fk_cd` FOREIGN KEY (`cd`) REFERENCES `cd` (`cdid`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `cd_to_producer`;

--
-- Table: `cd_to_producer`
--
CREATE TABLE `cd_to_producer` (
  `cd` integer NOT NULL,
  `producer` integer NOT NULL,
  `attribute` integer,
  INDEX `cd_to_producer_idx_cd` (`cd`),
  INDEX `cd_to_producer_idx_producer` (`producer`),
  PRIMARY KEY (`cd`, `producer`),
  CONSTRAINT `cd_to_producer_fk_cd` FOREIGN KEY (`cd`) REFERENCES `cd` (`cdid`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `cd_to_producer_fk_producer` FOREIGN KEY (`producer`) REFERENCES `producer` (`producerid`)
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `images`;

--
-- Table: `images`
--
CREATE TABLE `images` (
  `id` integer NOT NULL auto_increment,
  `artwork_id` integer NOT NULL,
  `name` varchar(100) NOT NULL,
  `data` blob,
  INDEX `images_idx_artwork_id` (`artwork_id`),
  PRIMARY KEY (`id`),
  CONSTRAINT `images_fk_artwork_id` FOREIGN KEY (`artwork_id`) REFERENCES `cd_artwork` (`cd_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `twokeys`;

--
-- Table: `twokeys`
--
CREATE TABLE `twokeys` (
  `artist` integer NOT NULL,
  `cd` integer NOT NULL,
  INDEX `twokeys_idx_artist` (`artist`),
  INDEX (`cd`),
  PRIMARY KEY (`artist`, `cd`),
  CONSTRAINT `twokeys_fk_artist` FOREIGN KEY (`artist`) REFERENCES `artist` (`artistid`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `twokeys_fk_cd` FOREIGN KEY (`cd`) REFERENCES `cd` (`cdid`)
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `artwork_to_artist`;

--
-- Table: `artwork_to_artist`
--
CREATE TABLE `artwork_to_artist` (
  `artwork_cd_id` integer NOT NULL,
  `artist_id` integer NOT NULL,
  INDEX `artwork_to_artist_idx_artist_id` (`artist_id`),
  INDEX `artwork_to_artist_idx_artwork_cd_id` (`artwork_cd_id`),
  PRIMARY KEY (`artwork_cd_id`, `artist_id`),
  CONSTRAINT `artwork_to_artist_fk_artist_id` FOREIGN KEY (`artist_id`) REFERENCES `artist` (`artistid`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `artwork_to_artist_fk_artwork_cd_id` FOREIGN KEY (`artwork_cd_id`) REFERENCES `cd_artwork` (`cd_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `fourkeys_to_twokeys`;

--
-- Table: `fourkeys_to_twokeys`
--
CREATE TABLE `fourkeys_to_twokeys` (
  `f_foo` integer NOT NULL,
  `f_bar` integer NOT NULL,
  `f_hello` integer NOT NULL,
  `f_goodbye` integer NOT NULL,
  `t_artist` integer NOT NULL,
  `t_cd` integer NOT NULL,
  `autopilot` character NOT NULL,
  `pilot_sequence` integer,
  INDEX `fourkeys_to_twokeys_idx_f_foo_f_bar_f_hello_f_goodbye` (`f_foo`, `f_bar`, `f_hello`, `f_goodbye`),
  INDEX `fourkeys_to_twokeys_idx_t_artist_t_cd` (`t_artist`, `t_cd`),
  PRIMARY KEY (`f_foo`, `f_bar`, `f_hello`, `f_goodbye`, `t_artist`, `t_cd`),
  CONSTRAINT `fourkeys_to_twokeys_fk_f_foo_f_bar_f_hello_f_goodbye` FOREIGN KEY (`f_foo`, `f_bar`, `f_hello`, `f_goodbye`) REFERENCES `fourkeys` (`foo`, `bar`, `hello`, `goodbye`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `fourkeys_to_twokeys_fk_t_artist_t_cd` FOREIGN KEY (`t_artist`, `t_cd`) REFERENCES `twokeys` (`artist`, `cd`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB;

SET foreign_key_checks=1;

