-- 
-- Created by SQL::Translator::Producer::PostgreSQL
-- Created on Sun Jan 22 09:32:02 2012
-- 
--
-- Table: artist
--
DROP TABLE "artist" CASCADE;
CREATE TABLE "artist" (
  "artistid" serial NOT NULL,
  "name" character varying(100),
  "rank" integer DEFAULT 13 NOT NULL,
  "charfield" character(10),
  PRIMARY KEY ("artistid"),
  CONSTRAINT "artist_name" UNIQUE ("name"),
  CONSTRAINT "u_nullable" UNIQUE ("charfield", "rank")
);

--
-- Table: bindtype_test
--
DROP TABLE "bindtype_test" CASCADE;
CREATE TABLE "bindtype_test" (
  "id" serial NOT NULL,
  "bytea" bytea,
  "blob" bytea,
  "clob" clob,
  "a_memo" memo,
  PRIMARY KEY ("id")
);

--
-- Table: collection
--
DROP TABLE "collection" CASCADE;
CREATE TABLE "collection" (
  "collectionid" serial NOT NULL,
  "name" character varying(100) NOT NULL,
  PRIMARY KEY ("collectionid")
);

--
-- Table: encoded
--
DROP TABLE "encoded" CASCADE;
CREATE TABLE "encoded" (
  "id" serial NOT NULL,
  "encoded" character varying(100),
  PRIMARY KEY ("id")
);

--
-- Table: event
--
DROP TABLE "event" CASCADE;
CREATE TABLE "event" (
  "id" serial NOT NULL,
  "starts_at" date NOT NULL,
  "created_on" timestamp NOT NULL,
  "varchar_date" character varying(20),
  "varchar_datetime" character varying(20),
  "skip_inflation" timestamp,
  "ts_without_tz" timestamp,
  PRIMARY KEY ("id")
);

--
-- Table: fourkeys
--
DROP TABLE "fourkeys" CASCADE;
CREATE TABLE "fourkeys" (
  "foo" integer NOT NULL,
  "bar" integer NOT NULL,
  "hello" integer NOT NULL,
  "goodbye" integer NOT NULL,
  "sensors" character(10) NOT NULL,
  "read_count" integer,
  PRIMARY KEY ("foo", "bar", "hello", "goodbye")
);

--
-- Table: genre
--
DROP TABLE "genre" CASCADE;
CREATE TABLE "genre" (
  "genreid" serial NOT NULL,
  "name" character varying(100) NOT NULL,
  PRIMARY KEY ("genreid"),
  CONSTRAINT "genre_name" UNIQUE ("name")
);

--
-- Table: link
--
DROP TABLE "link" CASCADE;
CREATE TABLE "link" (
  "id" serial NOT NULL,
  "url" character varying(100),
  "title" character varying(100),
  PRIMARY KEY ("id")
);

--
-- Table: money_test
--
DROP TABLE "money_test" CASCADE;
CREATE TABLE "money_test" (
  "id" serial NOT NULL,
  "amount" money,
  PRIMARY KEY ("id")
);

--
-- Table: noprimarykey
--
DROP TABLE "noprimarykey" CASCADE;
CREATE TABLE "noprimarykey" (
  "foo" integer NOT NULL,
  "bar" integer NOT NULL,
  "baz" integer NOT NULL,
  CONSTRAINT "foo_bar" UNIQUE ("foo", "bar")
);

--
-- Table: onekey
--
DROP TABLE "onekey" CASCADE;
CREATE TABLE "onekey" (
  "id" serial NOT NULL,
  "artist" integer NOT NULL,
  "cd" integer NOT NULL,
  PRIMARY KEY ("id")
);

--
-- Table: owners
--
DROP TABLE "owners" CASCADE;
CREATE TABLE "owners" (
  "id" serial NOT NULL,
  "name" character varying(100) NOT NULL,
  PRIMARY KEY ("id")
);

--
-- Table: producer
--
DROP TABLE "producer" CASCADE;
CREATE TABLE "producer" (
  "producerid" serial NOT NULL,
  "name" character varying(100) NOT NULL,
  PRIMARY KEY ("producerid"),
  CONSTRAINT "prod_name" UNIQUE ("name")
);

--
-- Table: self_ref
--
DROP TABLE "self_ref" CASCADE;
CREATE TABLE "self_ref" (
  "id" serial NOT NULL,
  "name" character varying(100) NOT NULL,
  PRIMARY KEY ("id")
);

--
-- Table: sequence_test
--
DROP TABLE "sequence_test" CASCADE;
CREATE TABLE "sequence_test" (
  "pkid1" integer NOT NULL,
  "pkid2" integer NOT NULL,
  "nonpkid" integer NOT NULL,
  "name" character varying(100),
  PRIMARY KEY ("pkid1", "pkid2")
);

--
-- Table: serialized
--
DROP TABLE "serialized" CASCADE;
CREATE TABLE "serialized" (
  "id" serial NOT NULL,
  "serialized" text NOT NULL,
  PRIMARY KEY ("id")
);

--
-- Table: timestamp_primary_key_test
--
DROP TABLE "timestamp_primary_key_test" CASCADE;
CREATE TABLE "timestamp_primary_key_test" (
  "id" timestamp DEFAULT current_timestamp NOT NULL,
  PRIMARY KEY ("id")
);

--
-- Table: treelike
--
DROP TABLE "treelike" CASCADE;
CREATE TABLE "treelike" (
  "id" serial NOT NULL,
  "parent" integer,
  "name" character varying(100) NOT NULL,
  PRIMARY KEY ("id")
);
CREATE INDEX "treelike_idx_parent" on "treelike" ("parent");

--
-- Table: twokeytreelike
--
DROP TABLE "twokeytreelike" CASCADE;
CREATE TABLE "twokeytreelike" (
  "id1" integer NOT NULL,
  "id2" integer NOT NULL,
  "parent1" integer NOT NULL,
  "parent2" integer NOT NULL,
  "name" character varying(100) NOT NULL,
  PRIMARY KEY ("id1", "id2"),
  CONSTRAINT "tktlnameunique" UNIQUE ("name")
);
CREATE INDEX "twokeytreelike_idx_parent1_parent2" on "twokeytreelike" ("parent1", "parent2");

--
-- Table: typed_object
--
DROP TABLE "typed_object" CASCADE;
CREATE TABLE "typed_object" (
  "objectid" serial NOT NULL,
  "type" character varying(100) NOT NULL,
  "value" character varying(100) NOT NULL,
  PRIMARY KEY ("objectid")
);

--
-- Table: artist_undirected_map
--
DROP TABLE "artist_undirected_map" CASCADE;
CREATE TABLE "artist_undirected_map" (
  "id1" integer NOT NULL,
  "id2" integer NOT NULL,
  PRIMARY KEY ("id1", "id2")
);
CREATE INDEX "artist_undirected_map_idx_id1" on "artist_undirected_map" ("id1");
CREATE INDEX "artist_undirected_map_idx_id2" on "artist_undirected_map" ("id2");

--
-- Table: bookmark
--
DROP TABLE "bookmark" CASCADE;
CREATE TABLE "bookmark" (
  "id" serial NOT NULL,
  "link" integer,
  PRIMARY KEY ("id")
);
CREATE INDEX "bookmark_idx_link" on "bookmark" ("link");

--
-- Table: books
--
DROP TABLE "books" CASCADE;
CREATE TABLE "books" (
  "id" serial NOT NULL,
  "source" character varying(100) NOT NULL,
  "owner" integer NOT NULL,
  "title" character varying(100) NOT NULL,
  "price" integer,
  PRIMARY KEY ("id"),
  CONSTRAINT "books_title" UNIQUE ("title")
);
CREATE INDEX "books_idx_owner" on "books" ("owner");

--
-- Table: employee
--
DROP TABLE "employee" CASCADE;
CREATE TABLE "employee" (
  "employee_id" serial NOT NULL,
  "position" integer NOT NULL,
  "group_id" integer,
  "group_id_2" integer,
  "group_id_3" integer,
  "name" character varying(100),
  "encoded" integer,
  PRIMARY KEY ("employee_id")
);
CREATE INDEX "employee_idx_encoded" on "employee" ("encoded");

--
-- Table: forceforeign
--
DROP TABLE "forceforeign" CASCADE;
CREATE TABLE "forceforeign" (
  "artist" integer NOT NULL,
  "cd" integer NOT NULL,
  PRIMARY KEY ("artist")
);

--
-- Table: self_ref_alias
--
DROP TABLE "self_ref_alias" CASCADE;
CREATE TABLE "self_ref_alias" (
  "self_ref" integer NOT NULL,
  "alias" integer NOT NULL,
  PRIMARY KEY ("self_ref", "alias")
);
CREATE INDEX "self_ref_alias_idx_alias" on "self_ref_alias" ("alias");
CREATE INDEX "self_ref_alias_idx_self_ref" on "self_ref_alias" ("self_ref");

--
-- Table: track
--
DROP TABLE "track" CASCADE;
CREATE TABLE "track" (
  "trackid" serial NOT NULL,
  "cd" integer NOT NULL,
  "position" integer NOT NULL,
  "title" character varying(100) NOT NULL,
  "last_updated_on" timestamp,
  "last_updated_at" timestamp,
  PRIMARY KEY ("trackid"),
  CONSTRAINT "track_cd_position" UNIQUE ("cd", "position"),
  CONSTRAINT "track_cd_title" UNIQUE ("cd", "title")
);
CREATE INDEX "track_idx_cd" on "track" ("cd");

--
-- Table: cd
--
DROP TABLE "cd" CASCADE;
CREATE TABLE "cd" (
  "cdid" serial NOT NULL,
  "artist" integer NOT NULL,
  "title" character varying(100) NOT NULL,
  "year" character varying(100) NOT NULL,
  "genreid" integer,
  "single_track" integer,
  PRIMARY KEY ("cdid"),
  CONSTRAINT "cd_artist_title" UNIQUE ("artist", "title")
);
CREATE INDEX "cd_idx_artist" on "cd" ("artist");
CREATE INDEX "cd_idx_genreid" on "cd" ("genreid");
CREATE INDEX "cd_idx_single_track" on "cd" ("single_track");

--
-- Table: collection_object
--
DROP TABLE "collection_object" CASCADE;
CREATE TABLE "collection_object" (
  "collection" integer NOT NULL,
  "object" integer NOT NULL,
  PRIMARY KEY ("collection", "object")
);
CREATE INDEX "collection_object_idx_collection" on "collection_object" ("collection");
CREATE INDEX "collection_object_idx_object" on "collection_object" ("object");

--
-- Table: lyrics
--
DROP TABLE "lyrics" CASCADE;
CREATE TABLE "lyrics" (
  "lyric_id" serial NOT NULL,
  "track_id" integer NOT NULL,
  PRIMARY KEY ("lyric_id")
);
CREATE INDEX "lyrics_idx_track_id" on "lyrics" ("track_id");

--
-- Table: cd_artwork
--
DROP TABLE "cd_artwork" CASCADE;
CREATE TABLE "cd_artwork" (
  "cd_id" integer NOT NULL,
  PRIMARY KEY ("cd_id")
);

--
-- Table: liner_notes
--
DROP TABLE "liner_notes" CASCADE;
CREATE TABLE "liner_notes" (
  "liner_id" integer NOT NULL,
  "notes" character varying(100) NOT NULL,
  PRIMARY KEY ("liner_id")
);

--
-- Table: lyric_versions
--
DROP TABLE "lyric_versions" CASCADE;
CREATE TABLE "lyric_versions" (
  "id" serial NOT NULL,
  "lyric_id" integer NOT NULL,
  "text" character varying(100) NOT NULL,
  PRIMARY KEY ("id")
);
CREATE INDEX "lyric_versions_idx_lyric_id" on "lyric_versions" ("lyric_id");

--
-- Table: tags
--
DROP TABLE "tags" CASCADE;
CREATE TABLE "tags" (
  "tagid" serial NOT NULL,
  "cd" integer NOT NULL,
  "tag" character varying(100) NOT NULL,
  PRIMARY KEY ("tagid"),
  CONSTRAINT "tagid_cd" UNIQUE ("tagid", "cd"),
  CONSTRAINT "tagid_cd_tag" UNIQUE ("tagid", "cd", "tag"),
  CONSTRAINT "tags_tagid_tag" UNIQUE ("tagid", "tag"),
  CONSTRAINT "tags_tagid_tag_cd" UNIQUE ("tagid", "tag", "cd")
);
CREATE INDEX "tags_idx_cd" on "tags" ("cd");

--
-- Table: cd_to_producer
--
DROP TABLE "cd_to_producer" CASCADE;
CREATE TABLE "cd_to_producer" (
  "cd" integer NOT NULL,
  "producer" integer NOT NULL,
  "attribute" integer,
  PRIMARY KEY ("cd", "producer")
);
CREATE INDEX "cd_to_producer_idx_cd" on "cd_to_producer" ("cd");
CREATE INDEX "cd_to_producer_idx_producer" on "cd_to_producer" ("producer");

--
-- Table: images
--
DROP TABLE "images" CASCADE;
CREATE TABLE "images" (
  "id" serial NOT NULL,
  "artwork_id" integer NOT NULL,
  "name" character varying(100) NOT NULL,
  "data" bytea,
  PRIMARY KEY ("id")
);
CREATE INDEX "images_idx_artwork_id" on "images" ("artwork_id");

--
-- Table: twokeys
--
DROP TABLE "twokeys" CASCADE;
CREATE TABLE "twokeys" (
  "artist" integer NOT NULL,
  "cd" integer NOT NULL,
  PRIMARY KEY ("artist", "cd")
);
CREATE INDEX "twokeys_idx_artist" on "twokeys" ("artist");

--
-- Table: artwork_to_artist
--
DROP TABLE "artwork_to_artist" CASCADE;
CREATE TABLE "artwork_to_artist" (
  "artwork_cd_id" integer NOT NULL,
  "artist_id" integer NOT NULL,
  PRIMARY KEY ("artwork_cd_id", "artist_id")
);
CREATE INDEX "artwork_to_artist_idx_artist_id" on "artwork_to_artist" ("artist_id");
CREATE INDEX "artwork_to_artist_idx_artwork_cd_id" on "artwork_to_artist" ("artwork_cd_id");

--
-- Table: fourkeys_to_twokeys
--
DROP TABLE "fourkeys_to_twokeys" CASCADE;
CREATE TABLE "fourkeys_to_twokeys" (
  "f_foo" integer NOT NULL,
  "f_bar" integer NOT NULL,
  "f_hello" integer NOT NULL,
  "f_goodbye" integer NOT NULL,
  "t_artist" integer NOT NULL,
  "t_cd" integer NOT NULL,
  "autopilot" character NOT NULL,
  "pilot_sequence" integer,
  PRIMARY KEY ("f_foo", "f_bar", "f_hello", "f_goodbye", "t_artist", "t_cd")
);
CREATE INDEX "fourkeys_to_twokeys_idx_f_foo_f_bar_f_hello_f_goodbye" on "fourkeys_to_twokeys" ("f_foo", "f_bar", "f_hello", "f_goodbye");
CREATE INDEX "fourkeys_to_twokeys_idx_t_artist_t_cd" on "fourkeys_to_twokeys" ("t_artist", "t_cd");

--
-- View: "year2000cds"
--
DROP VIEW "year2000cds";
CREATE VIEW "year2000cds" ( "cdid", "artist", "title", "year", "genreid", "single_track" ) AS
    SELECT cdid, artist, title, year, genreid, single_track FROM cd WHERE year = "2000"
;

--
-- Foreign Key Definitions
--

ALTER TABLE "treelike" ADD FOREIGN KEY ("parent")
  REFERENCES "treelike" ("id") ON DELETE CASCADE ON UPDATE CASCADE DEFERRABLE;

ALTER TABLE "twokeytreelike" ADD FOREIGN KEY ("parent1", "parent2")
  REFERENCES "twokeytreelike" ("id1", "id2") DEFERRABLE;

ALTER TABLE "artist_undirected_map" ADD FOREIGN KEY ("id1")
  REFERENCES "artist" ("artistid") ON DELETE RESTRICT ON UPDATE CASCADE DEFERRABLE;

ALTER TABLE "artist_undirected_map" ADD FOREIGN KEY ("id2")
  REFERENCES "artist" ("artistid") DEFERRABLE;

ALTER TABLE "bookmark" ADD FOREIGN KEY ("link")
  REFERENCES "link" ("id") ON DELETE SET NULL ON UPDATE CASCADE DEFERRABLE;

ALTER TABLE "books" ADD FOREIGN KEY ("owner")
  REFERENCES "owners" ("id") ON DELETE CASCADE ON UPDATE CASCADE DEFERRABLE;

ALTER TABLE "employee" ADD FOREIGN KEY ("encoded")
  REFERENCES "encoded" ("id") ON DELETE CASCADE ON UPDATE CASCADE DEFERRABLE;

ALTER TABLE "forceforeign" ADD FOREIGN KEY ("artist")
  REFERENCES "artist" ("artistid") DEFERRABLE;

ALTER TABLE "self_ref_alias" ADD FOREIGN KEY ("alias")
  REFERENCES "self_ref" ("id") DEFERRABLE;

ALTER TABLE "self_ref_alias" ADD FOREIGN KEY ("self_ref")
  REFERENCES "self_ref" ("id") ON DELETE CASCADE ON UPDATE CASCADE DEFERRABLE;

ALTER TABLE "track" ADD FOREIGN KEY ("cd")
  REFERENCES "cd" ("cdid") ON DELETE CASCADE ON UPDATE CASCADE DEFERRABLE;

ALTER TABLE "cd" ADD FOREIGN KEY ("artist")
  REFERENCES "artist" ("artistid") ON DELETE CASCADE ON UPDATE CASCADE DEFERRABLE;

ALTER TABLE "cd" ADD FOREIGN KEY ("genreid")
  REFERENCES "genre" ("genreid") ON DELETE SET NULL ON UPDATE CASCADE DEFERRABLE;

ALTER TABLE "cd" ADD FOREIGN KEY ("single_track")
  REFERENCES "track" ("trackid") ON DELETE CASCADE DEFERRABLE;

ALTER TABLE "collection_object" ADD FOREIGN KEY ("collection")
  REFERENCES "collection" ("collectionid") ON DELETE CASCADE ON UPDATE CASCADE DEFERRABLE;

ALTER TABLE "collection_object" ADD FOREIGN KEY ("object")
  REFERENCES "typed_object" ("objectid") ON DELETE CASCADE ON UPDATE CASCADE DEFERRABLE;

ALTER TABLE "lyrics" ADD FOREIGN KEY ("track_id")
  REFERENCES "track" ("trackid") ON DELETE CASCADE DEFERRABLE;

ALTER TABLE "cd_artwork" ADD FOREIGN KEY ("cd_id")
  REFERENCES "cd" ("cdid") ON DELETE CASCADE DEFERRABLE;

ALTER TABLE "liner_notes" ADD FOREIGN KEY ("liner_id")
  REFERENCES "cd" ("cdid") ON DELETE CASCADE DEFERRABLE;

ALTER TABLE "lyric_versions" ADD FOREIGN KEY ("lyric_id")
  REFERENCES "lyrics" ("lyric_id") ON DELETE CASCADE ON UPDATE CASCADE DEFERRABLE;

ALTER TABLE "tags" ADD FOREIGN KEY ("cd")
  REFERENCES "cd" ("cdid") ON DELETE CASCADE ON UPDATE CASCADE DEFERRABLE;

ALTER TABLE "cd_to_producer" ADD FOREIGN KEY ("cd")
  REFERENCES "cd" ("cdid") ON DELETE CASCADE ON UPDATE CASCADE DEFERRABLE;

ALTER TABLE "cd_to_producer" ADD FOREIGN KEY ("producer")
  REFERENCES "producer" ("producerid") DEFERRABLE;

ALTER TABLE "images" ADD FOREIGN KEY ("artwork_id")
  REFERENCES "cd_artwork" ("cd_id") ON DELETE CASCADE ON UPDATE CASCADE DEFERRABLE;

ALTER TABLE "twokeys" ADD FOREIGN KEY ("artist")
  REFERENCES "artist" ("artistid") ON DELETE CASCADE ON UPDATE CASCADE DEFERRABLE;

ALTER TABLE "twokeys" ADD FOREIGN KEY ("cd")
  REFERENCES "cd" ("cdid");

ALTER TABLE "artwork_to_artist" ADD FOREIGN KEY ("artist_id")
  REFERENCES "artist" ("artistid") ON DELETE CASCADE ON UPDATE CASCADE DEFERRABLE;

ALTER TABLE "artwork_to_artist" ADD FOREIGN KEY ("artwork_cd_id")
  REFERENCES "cd_artwork" ("cd_id") ON DELETE CASCADE ON UPDATE CASCADE DEFERRABLE;

ALTER TABLE "fourkeys_to_twokeys" ADD FOREIGN KEY ("f_foo", "f_bar", "f_hello", "f_goodbye")
  REFERENCES "fourkeys" ("foo", "bar", "hello", "goodbye") ON DELETE CASCADE ON UPDATE CASCADE DEFERRABLE;

ALTER TABLE "fourkeys_to_twokeys" ADD FOREIGN KEY ("t_artist", "t_cd")
  REFERENCES "twokeys" ("artist", "cd") ON DELETE CASCADE ON UPDATE CASCADE DEFERRABLE;

